var fs = require('fs'),
	nconf = require('nconf')

function filter(confFile) {
	this.confFile = confFile
	this.filters = nconf.get('conf:filters') || {
		retweeter:[],
		source:[],
		text:[],
		user:[],
	}
}

filter.prototype.get = function(type) {
	if(this.filters[type] !== undefined) {
		return this.filters[type]
	} else {
		return null
	}
}

filter.prototype.add = function(type, filter) {
	if(this.filters[type] === undefined) {
		this.filters[type] = []
	}
	this.filters[type].push(filter)

	this.save()
}

filter.prototype.delId = function(type, filterId) {
	if(this.filters[type] === undefined) {
		return
	}

	this.filters[type].slice(filterId, filterId)
	this.save()
}

filter.prototype.save = function() {
	fs.writeFileSync(this.confFile, JSON.stringify({ conf: nconf.get('conf') }, null, 2), 'utf8')
}

module.exports = filter
