var EventEmitter = require('events').EventEmitter,
	util = require('util'),
	pkg = require('../package.json')

function statusbar() {
	EventEmitter.call(this)
	this.current = null
	this.change = null
	this.defaultMessage = util.format('[rumble %s]', pkg.version)
	this.defaultStyle = 'STATUSBAR'
	this.emit('update', this.defaultMessage, this.defaultStyle)
}
util.inherits(statusbar, EventEmitter)

statusbar.prototype.hold = function(message, style) {
	if(style === undefined) style = this.defaultStyle
	this.emit('update', message, style)
	this.emit('hidechars')
}

statusbar.prototype.flash = function(message, time, style) {
	var self = this
	if(style === undefined) style = this.defaultStyle
	this.emit('update', message, style)
	this.emit('hidechars')
	if(this.change !== null)
		clearTimeout(this.change)
	this.change = setTimeout(function() {
		self.emit('update', self.defaultMessage, self.defaultStyle)
		self.emit('showchars')
		self.change = null
	}, time * 1000)
}

statusbar.prototype.reset = function() {
	clearTimeout(this.change)
	this.change = null
	this.emit('update', this.defaultMessage, this.defaultStyle)
	this.emit('showchars')
}

var instance = new statusbar()
module.exports = instance
