module.exports = function(nc) {
	theme = {}

	/**
	 * ==============================================================================
	 * modify the following to easily change the theme of rumble
	 * for better information on what states/colors are available,
	 *  consult the most excellent node-ncurses documentation in its readme
	 * ==============================================================================
	 */
	theme.elements = {
		// statusbar
		STATUSBAR:[
			nc.colorPair(1, nc.colors.WHITE, nc.colors.RED)
		],

		STATUSBAR_WARN:[
			nc.colorPair(9, nc.colors.BLACK, nc.colors.YELLOW)
		],

		STATUSBAR_ERR:[
			nc.colorPair(10, nc.colors.RED, nc.colors.YELLOW)
		],

		IDBAR_NORMAL:[
			nc.attrs.BOLD,
			nc.colorPair(5, nc.colors.BLACK, nc.attrs.NORMAL)
		],

		IDBAR_NOTICE:[
			nc.colorPair(4, nc.colors.YELLOW, nc.attrs.NORMAL)
		],

		IDBAR_ALERT:[
			nc.colorPair(6, nc.colors.RED, nc.attrs.NORMAL)
		],


		IDBAR_HIGHLIGHT:[
			nc.attrs.BOLD,
			nc.colorPair(6, nc.colors.YELLOW, nc.colors.MAGENTA)
		],

		// urls in tweets
		TWEET_URL:[
			nc.attrs.BOLD,
			nc.colorPair(2, nc.colors.BLUE, nc.attrs.NORMAL)
		],

		// hashtag
		TWEET_HASHTAG:[
			nc.colorPair(3, nc.colors.MAGENTA, nc.attrs.NORMAL)
		],

		// mentions
		TWEET_MENTION:[
			nc.colorPair(4, nc.colors.YELLOW, nc.attrs.NORMAL)
		],

		// date
		TWEET_DATE:[
			nc.attrs.BOLD,
			nc.colorPair(5, nc.colors.BLACK, nc.attrs.NORMAL)
		],

		// extra ("via" message)
		TWEET_EXTRA:[
			nc.attrs.BOLD,
			nc.colorPair(5, nc.colors.BLACK, nc.attrs.NORMAL)
		],

		// source
		TWEET_SOURCE:[
			nc.colorPair(6, nc.colors.RED, nc.attrs.NORMAL)
		],

		// tweet author
		TWEET_AUTHOR:[
			nc.colorPair(7, nc.colors.CYAN, nc.attrs.NORMAL)
		],

		// normal tweet text
		TWEET_TEXT:[
			nc.colorPair(8, nc.colors.WHITE, nc.attrs.NORMAL)
		],

		UI_MESSAGE:[
			nc.attrs.BOLD,
			nc.colorPair(8, nc.colors.WHITE, nc.attrs.NORMAL)
		],

		// DO NOT MODIFY.
		FALLBACK:[
			nc.colorPair(8, nc.colors.WHITE, nc.attrs.NORMAL)
		],
	}

	/**
	 * ==============================================================================
	 * don't modify ANYTHING beyond this point!
	 * ==============================================================================
	 */
	Object.freeze(theme.elements)

	theme.apply = function(win, type, content) {
		var attrs = theme.elements['FALLBACK']
		if(theme.elements[type] !== undefined)
			attrs = theme.elements[type]

		attrs.forEach(function(attr) {
			win.attron(attr)
		})
		win.print(content)
		attrs.reverse().forEach(function(attr) {
			win.attroff(attr)
		})

		return type
	}

	return theme
}
