var wcwidth = require('wcwidth.js')({
    nul:     0,
    control: 1
})

module.exports =
// based on the wordwrap module
// https://github.com/substack/node-wordwrap
function wordwrap(text, stop) {
	var start = 0
	var chunks = text.toString().split(/(\S+\s+)/).reduce(function(acc, x) {
		if(x !== '')
			acc.push(x)
		return acc
	}, [])

	return chunks.reduce(function (lines, chunk) {
		var i = lines.length - 1
		if(lines[i].wcwidth + chunk.wcwidth > stop || lines[i][lines[i].length - 1] === '\n') {
			if(chunk.wcwidth > stop) {
				// check to see if we have wide characters which will throw off display
				// if we do have any, we'll have to use a slower splitting method - otherwise, we do this shit as fast as possible
				//
				// I'm sorry for the following code.  It's not very elegant, but at least it works.
				if(chunk.wcwidth !== chunk.length) {
					// because there's no other accurate way to split based on "width", we have to go by it incrementally.
					// we're saving a *little* effort by doing it in slices of two, but...eh. increasing the distance can cause more problems.
					var lchunk = '', piece = ''
					for(var i = 0; i < chunk.length; i+=2) {
						piece = chunk.slice(i, i+2)
						if(lchunk.wcwidth + piece.wcwidth > stop) {
							lines.push(lchunk)
							lchunk = piece
						} else {
							lchunk += piece
						}
					}
					// push the last "line chunk"
					lines.push(lchunk)
				} else {
					for(var i = 0, pieces = Math.floor(chunk.wcwidth / stop); i <= pieces; i++) {
						lines.push(chunk.slice(i * stop, (i+1) * stop))
					}
				}
			} else {
				lines.push(chunk)
			}
		} else {
			lines[i] += chunk
		}

		return lines
	}, ['']).reduce(function(out, chunk) {
		if(out[out.length - 1] !== '\n' && out.length > 0)
			out += '\n'
		return out + chunk
	}, '')
}
