![rumble.js](http://i.imgur.com/8iXYLS2.png)

a straightforward streaming twitter client made for commandline, inspired by [earthquake](https://github.com/jugyo/earthquake).

## dependencies

* ncurses
* node >= 0.8.0

## installation (via npm)

global installation:

    # npm install -g rumble@1.0

local installation

	$ npm install rumble@1.0

note: local installation means you need to cd to appropriate directory and use `node rumble` to run the client.

## installation (via git)

	$ git clone git://github.com/damianb/rumble.git
	$ cd rumble
	$ npm install

to run, use `node rumble`

## authorization

run rumble the first time with the `-a` flag to initiate authorization.

## commands

**note:** default command prefix is `:`, adjust directions accordingly if you change the command prefix.

**note:** `$xx` should be substituted with the line id to execute the specified command on

* `<message>` = tweet the specified message
* `:reply $xx <message>` - `:r $xx <message>` - `:$xx <message>` = reply to the specified tweet with the specified message
* `:retweet $xx` - `:rt $xx` = retweet the specified tweet
* `:favorite $xx` - `:fav $xx` = favorite the specified tweet
* `:unfavorite $xx` - `:unfav $xx` = unfavorite the specified tweet
* `:delete $xx` - `:del $xx` = favorite the specified tweet
* `:link $xx` = get a URL to view the specified tweet at
* `:quit` - `:q` = quit rumble

## license

MIT License

## known problems

resize does not work due to an upstream node-ncurses problem.  nothing I can do until node-ncurses handles resizing the main window properly. T_T

## todo

* proper error notification (via statusbar, not console.error's pipe to error.log)
* tweet search
* highlighting (possibly notifications? could abuse libnotify for linux systems)
* last mentions
* on-the-fly filter management
* tweet lookup (by id)
* follow/unfollow user
* block/unblock user
* manage current blocks
* view user profile
* alter own profile
* set avatar (?)
* eval command (to allow for quick math operations or the like?)
* get data for specific lineId (special data, like tweet id? mentioned users?)
* increase flexibility, more configurability (scrolling, prompt text)
