#! /usr/bin/env node

/**
 * libs
 */
var app = require('commander'),
	nconf = require('nconf'),
	rumble = require('./lib/rumble'),
	setlocale = require('setlocale'),
	fs = require('fs'),

	// special vars
	pkg = require(__dirname + '/package.json'),
	home = process.env[(process.platform === 'win32') ? 'USERPROFILE' : 'HOME']

/**
 * commander.js definitions
 */
app
	.version(pkg.version)
	.description(pkg.description)
	.option('-a, --authorize', 're-authorize rumble for twitter access')
	.option('-c, --conf <conf>', 'specify the configuration file to use for rumble. defaults to "~/.rumble_conf.json"')
	.parse(process.argv)

var confFile = app.conf || home + '/.rumble_conf.json'

// nconf stuff
nconf.file({file: confFile})
nconf.defaults({
	conf:{
		twitter:{
			consumer_key: '',
			consumer_secret: '',
			access_token: '',
			access_token_secret: '',
			self_user_id: ''
		},
		filter:{
			retweeter:[],
			source:[],
			text:[],
			user:[],
		},
		app:{
			prompt:"> "
		}
	}
})

setlocale.setlocale(setlocale.LC_ALL, '')

// for the time being, we're going to do something...evil.  Good for testing though. *shrug*
var errorLog = fs.createWriteStream(__dirname + '/error.log', {flags:'a'})
process.__defineGetter__('stderr', function() { return errorLog })

var r = new rumble(nconf, confFile)

if(app.authorize) {
	r.authorize(app)
} else {
	r.runtime(app)
}
